/*
 * Copyright (c) 2003 FlashCode <flashcode@flashtux.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _GMEMO_MEMO_H
#define _GMEMO_MEMO_H  1

#include <gtk/gtk.h>

#include "gmemo.h"


#define REPEAT_NONE     0
#define REPEAT_SEC      1
#define REPEAT_MIN      2
#define REPEAT_HOUR     3
#define REPEAT_DAY      4
#define REPEAT_WEEK     5
#define REPEAT_MONTH    6
#define REPEAT_YEAR     7
#define REPEAT_LAST     REPEAT_YEAR
#define NUM_REPEAT      (REPEAT_LAST + 1)


typedef struct
{
    gboolean    active;             // active memo (false = old memo, discarded)
    gchar       *short_lib;         // short description of memo
    gchar       *long_lib;          // long description of memo
    glong       alarm;              // date/time of alarm (read from file)
    glong       last_alarm;         // last date/time alarm was displayed (0 = never displayed)
    glong       next_alarm;         // date/time of next alarm (calculated by program)
    gint        repeat_type;        // repeat type
    gint        interval;           // number of [units]
    gint        repeat_remaining;   // remaining repeats (-1 = infinite repeats)
    gchar       *sound_file;        // sound filename for alarm
    gchar       *cmd_exec;          // command to execute when alarm
    gchar       *cmd_args;          // arguments for command
} t_memo;


extern gchar    *repeat_strings[NUM_REPEAT];
extern GSList   *memos;


extern gint get_num_days_month(gint, gint);
extern glong date_to_glong(gint, gint, gint, gint, gint, gint);
extern void set_first_alarm(t_memo *);
extern void display_memos(GSList *);
extern void check_alarms();
extern void destroy_memos();

#endif /* gmemo_memo.h */
